質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.20%

コントローラーの抽象化クラスを継承したい(Zendframework1.12)

受付中

回答 1

投稿

  • 評価
  • クリップ 1
  • VIEW 1,108

ciash8

score 8

Zendframework1.12でコントローラープラグインの設定

PHPでフレームワークにZendframeworkを使ってWebアプリケーションを作成しているのですが、抽象化クラスの設定が上手くいっていないのかクラスの継承でエラーが出ています。
Zend_Controller_Plugin_Abstractを継承して抽象化クラスを作り、それをIndexController.phpで継承する形でつくっているのですが、何がおかしいのかがわからない状態です。。
Zend_Controller_Actionを直接継承することはできるのですが、プラグインを使いたいので一つ挟みたいのですが、、
(commonモジュールに該当ファイル置いていますが、パスは通しています。

発生している問題・エラーメッセージ

Fatal error: Class 'Common_Model_Controller_Action' not found in /Applications/MAMP/・・・略・・・/default/controllers/IndexController.php on line 5

該当のソースコード

-- IndexController.php
class IndexController extends Common_Model_Controller_Action
{
    // 処理
}

-- Action.php
abstract class Common_Model_Controller_Action extends Zend_Controller_Action
{

    function init()
    {
        // コントローラーのプラグイン設定
        $front = Zend_Controller_Front::getInstance();
        $front->registerPlugin(new Zend_Controller_Plugin_Abstract());
    }
}

補足情報(言語/FW/ツール等のバージョンなど)

php7.0.15/zendframework1.12.20/

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

0

not foundのエラーメッセージのままAction.phpの置き場所が間違ってるのだと思います。
一番簡単な解決方法は抽象化クラス使わないこと。
プラグインの設定くらいは各コントローラーに書けばいいことです。

そもそもの原因として1.12は古すぎるので最新バージョン使ったほうがいいです。
最新バージョンならcomposerなのでこの辺りはもっと分かりやすいはずです。

今からZF1覚えてもどうにもなりません。
5年以上前に使いましたが2への移行が難しいので結局全部捨てました。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/08/24 23:10

    回答ありがとうございます。
    やはりそういう感じですかね。。

    そうですね、、今はちょっと事情で触ったことあるものをと思ったのですが、結局詰まってるので、バージョン新しいもの、あるいはZF以外のもの学習していきます!

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.20%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる